class Correo():

        def __init__(self):
            # librerias necesarias para el correo
            from email.mime.multipart import MIMEMultipart

            #inicializacion de variables
            self.asunto = "Sin Asunto"

            self.msg = MIMEMultipart()

            self.host=""
            self.servidor=None
            ## parámetros para el mensaje

            self.cabecera=""
            self.destinatarios=[]
            self.cuerpo=""
            self.password = ""
            self.adjuntos=[]
            self.mensaje=""
            self.eliminar_archivos_adjuntos=False
            self.inicioBoostrap = f"""
                           <!doctype html>
                           <html lang="en">
                           <head>
                           <!-- Required meta tags -->
                           <meta charset="utf-8">
                           <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

                           <!-- Bootstrap CSS -->
                           <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">

                           <title></title>
                           </head>
                           <body>
                           """

            self.finBoostrap = """
                           <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
                           <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>
                            </body>
                            </html>
                           """
            self.cuerpo="""
                        <p>rellene aqui su cuerpo de mensaje en formato <b>WEB</b></p>
                        """
            self.errores=[]
        def login(self):
            import sys
            self.errores.clear()
            try:
                self.servidor.login(self.msg["From"], self.password)
            except:

                e = sys.exc_info()[1]
                error=f"login():no se ha podido logear en el servidor de correo: codigo err:{e.args[0]} - descripcion:{e.args[1]}"
                self.errores.append(error)

        def conexion_servidor(self):
            import smtplib
            import sys
            try:
                self.servidor = smtplib.SMTP(host=f"{self.host}: 587")
            except:
                e = sys.exc_info()[1]
                error = f"login():no se ha podido conectar con el servidor de correo: codigo err:{e.args[0]} - descripcion:{e.args[1]}"
                self.errores.append(error)
        def adjuntar_archivo_excel(self,ruta):
            import sys
            from email.mime.base import MIMEBase
            from email import encoders

            self.errores.clear()
            try:
                fp =open(ruta,'rb')
                part = MIMEBase('application', 'vnd.ms-excel')
                part.set_payload(fp.read())
                fp.close()
                encoders.encode_base64(part)
                part.add_header('Content-Disposition', 'attachment', filename=ruta)
                return part
            except:
                part=None
                e = sys.exc_info()[1]
                error = f"Adjuntar_archivo_excel():no se ha podido Adjuntar el Excel: codigo err:{e.args[0]} - descripcion:{e.args[1]}"
                self.errores.append(error)
                return part

        def enviar(self):
            self.errores.clear()
            ##librerias necesarias
            from email.mime.text import MIMEText
            from os import remove
            #conectamos con el servidor
            self.conexion_servidor()

            #aqui agregamos los destinatarios
            if not self.destinatarios:
                error="error al enviar a  los destinatarios, destinatarios vacíos"
                self.errores.append(error)

            else:
                self.msg["To"] = ','.join(self.destinatarios)
            #montamos el mensaje
            self.mensaje=self.inicioBoostrap+self.cuerpo+self.finBoostrap
            self.msg.attach(MIMEText(self.mensaje, 'html'))
            if(len(self.errores)==0):
                self.login()
            ## si ya hemos hecho login seguimos con el procedimiento para adjuntar los archivos
            if(len(self.errores)==0):
                #aqui adjuntaremos los archivos para adjuntar
                #comprobamos que hallan adjuntos para poder subir
                if self.adjuntos:
                    for adjunto in self.adjuntos:
                        parte=self.adjuntar_archivo_excel(adjunto)
                        #si hemos podido adjuntar el archivo de excel a la clase mensaje
                        if(parte!=None):
                            self.msg.attach(parte)
                        #aqui diremos si queremos borrar o no el archivo
                        if(self.eliminar_archivos_adjuntos==True):
                            try:
                                remove(adjunto)
                            except:
                                mensaje=f"Error al eliminar el  adjunto: Ruta {adjunto}"

                ##aqui realizaremos el envio del mensaje

                self.msg["Subject"] = self.asunto
                for destinatario in self.destinatarios:
                    self.servidor.sendmail(self.msg["From"], destinatario, self.msg.as_string())



        def mostrar_errores(self):
            cont=0
            for error in self.errores:
                cont+=1
                print(f"{cont} :{error}")
        def mostrar_variables_correo(self):
            contenido=f"""
            ############## Variables de Conexion ######
            host:{self.host}
            usuario:{self.msg["From"]}
            password:{self.password}
            ###########################################
            """
            print(contenido)
